--This file computes Betti tables for P^1 for d = 7 and b = 5
A := degreesRing 2
new HashTable from {
--tb stands for Total Betti numbers
"tb"=>new HashTable from {(6,1) => 1, (0,0) => 6, (1,0) => 35, (0,1) => 0, (1,1) => 0, (2,0) => 84, (2,1) => 0, (3,0) => 105, (3,1) => 0, (4,0) => 70, (4,1) => 0, (5,0) => 21, (5,1) => 0, (6,0) => 0},
--mb stands for Multigraded Betti numbers
"mb"=>new HashTable from {(6,1) => A_0^27*A_1^27, (0,0) => A_0^5+A_0^4*A_1+A_0^3*A_1^2+A_0^2*A_1^3+A_0*A_1^4+A_1^5, (0,1) => 0, (1,0) => A_0^11*A_1+2*A_0^10*A_1^2+3*A_0^9*A_1^3+4*A_0^8*A_1^4+5*A_0^7*A_1^5+5*A_0^6*A_1^6+5*A_0^5*A_1^7+4*A_0^4*A_1^8+3*A_0^3*A_1^9+2*A_0^2*A_1^10+A_0*A_1^11, (2,0) => A_0^16*A_1^3+2*A_0^15*A_1^4+4*A_0^14*A_1^5+6*A_0^13*A_1^6+8*A_0^12*A_1^7+10*A_0^11*A_1^8+11*A_0^10*A_1^9+11*A_0^9*A_1^10+10*A_0^8*A_1^11+8*A_0^7*A_1^12+6*A_0^6*A_1^13+4*A_0^5*A_1^14+2*A_0^4*A_1^15+A_0^3*A_1^16, (1,1) => 0, (2,1) => 0, (3,0) => A_0^20*A_1^6+2*A_0^19*A_1^7+4*A_0^18*A_1^8+6*A_0^17*A_1^9+9*A_0^16*A_1^10+11*A_0^15*A_1^11+13*A_0^14*A_1^12+13*A_0^13*A_1^13+13*A_0^12*A_1^14+11*A_0^11*A_1^15+9*A_0^10*A_1^16+6*A_0^9*A_1^17+4*A_0^8*A_1^18+2*A_0^7*A_1^19+A_0^6*A_1^20, (3,1) => 0, (4,0) => A_0^23*A_1^10+2*A_0^22*A_1^11+3*A_0^21*A_1^12+5*A_0^20*A_1^13+7*A_0^19*A_1^14+8*A_0^18*A_1^15+9*A_0^17*A_1^16+9*A_0^16*A_1^17+8*A_0^15*A_1^18+7*A_0^14*A_1^19+5*A_0^13*A_1^20+3*A_0^12*A_1^21+2*A_0^11*A_1^22+A_0^10*A_1^23, (4,1) => 0, (5,0) => A_0^25*A_1^15+A_0^24*A_1^16+2*A_0^23*A_1^17+2*A_0^22*A_1^18+3*A_0^21*A_1^19+3*A_0^20*A_1^20+3*A_0^19*A_1^21+2*A_0^18*A_1^22+2*A_0^17*A_1^23+A_0^16*A_1^24+A_0^15*A_1^25, (6,0) => 0, (5,1) => 0},
--sb represents the betti numbers as sums of Schur functors
"sb"=>new HashTable from {(6,1) => {({27,27},1)}, (0,0) => {({5,0},1)}, (1,0) => {({11,1},1)}, (0,1) => {}, (1,1) => {}, (2,0) => {({16,3},1)}, (2,1) => {}, (3,0) => {({20,6},1)}, (3,1) => {}, (4,0) => {({23,10},1)}, (4,1) => {}, (5,0) => {({25,15},1)}, (5,1) => {}, (6,0) => {}},
--dw encodes the dominant weights in each entry
"dw"=>new HashTable from {(6,1) => {{27,27}}, (0,0) => {{5,0}}, (1,0) => {{11,1}}, (0,1) => {}, (1,1) => {}, (2,0) => {{16,3}}, (2,1) => {}, (3,0) => {{20,6}}, (3,1) => {}, (4,0) => {{23,10}}, (4,1) => {}, (5,0) => {{25,15}}, (5,1) => {}, (6,0) => {}},
--lw encodes the lex leading weight in each entry
"lw"=>new HashTable from {(6,1) => {27,27}, (0,0) => {5,0}, (1,0) => {11,1}, (0,1) => {}, (1,1) => {}, (2,0) => {16,3}, (2,1) => {}, (3,0) => {20,6}, (3,1) => {}, (4,0) => {23,10}, (4,1) => {}, (5,0) => {25,15}, (5,1) => {}, (6,0) => {}},
--nr encodes the number of distinct representations in each entry
"nr"=>new HashTable from {(6,1) => 1, (0,0) => 1, (1,0) => 1, (0,1) => 0, (1,1) => 0, (2,0) => 1, (2,1) => 0, (3,0) => 1, (3,1) => 0, (4,0) => 1, (4,1) => 0, (5,0) => 1, (5,1) => 0, (6,0) => 0},
--nrm encodes the number of representations with multiplicity in each entry
"nrm"=>new HashTable from {(6,1) => 1, (0,0) => 1, (1,0) => 1, (0,1) => 0, (1,1) => 0, (2,0) => 1, (2,1) => 0, (3,0) => 1, (3,1) => 0, (4,0) => 1, (4,1) => 0, (5,0) => 1, (5,1) => 0, (6,0) => 0},
--er encodes the errors in the computed multigraded Hilbert series via our Schur method in each entry
"er"=>new HashTable from {(6,1) => 1, (0,0) => 6, (1,0) => 35, (0,1) => 0, (1,1) => 0, (2,0) => 84, (2,1) => 0, (3,0) => 105, (3,1) => 0, (4,0) => 70, (4,1) => 0, (5,0) => 21, (5,1) => 0, (6,0) => 0},
--bs encodes the Boij-Soederberg coefficients each entry
"bs"=>{5040/1},
}
